#ifndef DEBUG_H_INCLUDED
#define DEBUG_H_INCLUDED

#include "typedef.h"
#include "device.h"
#include "console.h"


#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

#define MAX_ARGS	(8)
#define	MAX_CHRS	(256)
#define	MAX_HIS		(11)

//------------------------------------------------------
//  j^[hEBhE C^[tF[X(?)NX
//------------------------------------------------------
class iMon : public Device, public ZCons {
private:
	int x;								// XW(j^[hł̕\ʒu)
	int y;								// YW(j^[hł̕\ʒu)
	
public:
	iMon( VM6 *, const ID& );			// RXgN^
	~iMon();							// fXgN^
	
	int X();							// XW擾
	int Y();							// YW擾
	void SetX( int );					// XWݒ
	void SetY( int );					// YWݒ
	
	virtual bool Init() = 0;			// 
	virtual void Update() = 0;			// EBhEXV
};


//------------------------------------------------------
//  _vEBhENX
//------------------------------------------------------
class cWndMem : public iMon {
private:
	WORD Addr;							// \AhX
	
public:
	cWndMem( VM6 *, const ID& );		// RXgN^
	~cWndMem();							// fXgN^
	
	bool Init();						// 
	void Update();						// EBhEXV
	
	void SetAddress( WORD );			// \AhXݒ
	WORD GetAddress();					// \AhX擾
};


//------------------------------------------------------
//  WX^EBhENX
//------------------------------------------------------
class cWndReg : public iMon {
private:
	
public:
	cWndReg( VM6 *, const ID& );		// RXgN^
	~cWndReg();							// fXgN^
	
	bool Init();						// 
	void Update();						// EBhEXV
};


//------------------------------------------------------
//  j^EBhENX
//------------------------------------------------------
class cWndMon : public iMon {
private:
	char KeyBuf[MAX_CHRS];				// L[̓obt@
	char HisBuf[MAX_HIS][MAX_CHRS];		// L[̓qXgobt@
	char *Argv[MAX_ARGS];				// ւ̃|C^z
	int Argc;							// ̌
	int ArgvCounter;					// Shift()pJE^
	
	struct argv{						// p
		int Type;	// ̎		ARGV_xxx
		int Val;	// ̒l			ARG_xxx ܂́A
		char *Str;	// ̕		Argv[xxx]Ɠ
		argv() : Type(0), Val(0), Str(NULL) {}
	} argv;
	
	int GetArg();						// 
	void Shift();						// zVtg
	void Exec( int );					// R}hs
	void Help( int );					// wv\
	
public:
	cWndMon( VM6 *, const ID& );		// RXgN^
	~cWndMon();							// fXgN^
	
	bool Init();						// 
	void Update();						// EBhEXV
	
	void KeyIn( int, bool, int );		// L[͏
	
	void BreakIn( WORD );				// u[N|CgB
};







//------------------------------------------------------
//  j^[hNX
//------------------------------------------------------
class Monitor {
private:
	VM6 *vm;
	iMon *dcn[3];
	
public:
	Monitor( VM6 * );					// RXgN^
	~Monitor();							// fXgN^
	
	bool Init();						// 
	void Update();						// EBhEXV
	
	int Width();						// j^[h EBhE擾
	int Height();						// j^[h EBhE擾
	
	// EBhE
	void SetAddress( WORD );			// \AhXݒ
	WORD GetAddress();					// \AhX擾
	
	// j^EBhE
	void KeyIn( int, bool, int );		// L[͏
	void BreakIn( WORD );				// u[N|CgB
};




#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

#endif	// DEBUG_H_INCLUDED
